local shaders = {}
shaders.palettemapping= love.graphics.newShader[[
	extern vec3 palette_colors[16];
	vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ){
		vec4 pixel = Texel(texture, texture_coords );//This is the current pixel color
		float mindiff = 300.0;
		int minindex = 0;
		float temp;
		float diffr;
		float diffg;
		float diffb;
		for (int i=0;i<16;i++){
			diffr = palette_colors[i][0]-pixel.r;
			diffg = palette_colors[i][1]-pixel.g;
			diffb = palette_colors[i][2]-pixel.b;
			temp = sqrt(diffr*diffr+diffg*diffg+diffb*diffb);
			if (temp < mindiff) { mindiff = temp;minindex=i; }
		}
  		pixel.r = palette_colors[minindex][0];
  		pixel.g = palette_colors[minindex][1];
  		pixel.b = palette_colors[minindex][2];
  		return pixel;
	}
]]
return shaders
