gen = {}

function gen:new(game,sprite,speedx,speedy,depth,ratiox,ratioy)

	local Background = game.objects.base:new(game,0,0,game.WIDTH,game.HEIGHT)
	Background.sprite = sprite
	Background:register("Background")
	Background.spritewidth = sprite:getWidth()
	Background.spriteheight = sprite:getHeight()
	Background.nbwidth = math.ceil(game.WIDTH/sprite:getWidth())+1
	Background.nbheight = math.ceil(game.HEIGHT/sprite:getHeight())+1
	Background.speedx = speedx or 0
	Background.speedy = speedy or 0
	Background.depth = depth or -2
	Background.ratiox = ratiox or 0.6
	Background.ratioy = ratioy or 0
	Background.offx = 0
	Background.offy = 0

	function Background:step(dt)
		self.offx = (self.offx + dt*self.speedx)%self.spritewidth
		self.offy = (self.offy + dt*self.speedy)%self.spriteheight
	end

	function Background:draw()
		local offx = math.floor((self.offx-self.game.camerax*self.ratiox)%self.spritewidth+0.5)
		local offy = math.floor((self.offy-self.game.cameray*self.ratioy)%self.spriteheight+0.5)
		local i=0
		local j=0
		for i=-1,self.nbwidth-1 do
			for j=-1,self.nbheight-1 do
				lg.draw(self.sprite,(i-1)*self.spritewidth+offx,(j-1)*self.spriteheight+offy)
			end
		end
	end

	return Background

end

return gen
