local gen = {}

function gen:new(game,args)
	if args.properties.semi==nil then args.properties.semi = true end
	local Car = game.objects.movingplatform:new(game,args)
	Car.direction = args.properties.direction or -1
	Car.rect.nofalltrough = true
	Car.speed = 40
	Car.args = args
	Car.sprites = game:getSpriteDir("cars/base/")
	Car.killer = args.properties.killer
	Car.spawner = args.properties.spawner
	Car.spawntimer = game:Timer(2.5)
	Car.spawntimer:tick(2.4)
	Car:register("Car")
	Car.depth = -0.5

	function Car:step(dt)
		if not (self.killer or self.spawner ) then
			self:move(self.direction*dt*self.speed,0)
			for i,v in ipairs(self.game:findName("Player")) do
				if self.rect:colliderect(v.rect,0,2) then
					local dir = 1
					if self.rect.center.x>v.rect.center.x then dir = -1 end
					v:yeet(dir*self.speed*7,v.gravityway*-1*self.speed*7)
				end
			end
		end
		if self.spawner then
			if self.spawntimer:tick(dt) then
				local c = self.game.objects.car:new(game,self.args)
				c.spawner = false
			end
		end
		if self.killer then
			local i
			local v
			for i,v in ipairs(self.game:findName("Car")) do
				if v.id~=self.id and v.rect:colliderect(self.rect,0,0) then
					self.game:delid(v.id)
				end
			end
		end
	end

	function Car:draw()
		local sprite = self.sprites[1]
		local hscale = 1
		local hoffset = 0
		if self.direction<0 then
			hscale = -1
			hoffset = sprite:getWidth()
		end
		if not (self.spawner or self.killer) then
			lg.draw(sprite,self.rect.x-self.game.camerax,self.rect.y-self.game.cameray,0,hscale,1,hoffset,0)
		end
	end

	return Car

end

return gen
