local gen = {}

function gen:new(game,args)

	args.properties["sprite"] = args.properties["sprite"] or "donut.png"
	args.properties["semi"] = false
	args.properties["drag"] = true
	local Carrot = game.objects.movingplatform:new(game,args)
	Carrot:register("Carrot")
	Carrot.sprout = game:newImage("platforms/carrot/sprout.png")
	Carrot.top = game:newImage("platforms/carrot/top.png")
	Carrot.mid = game:newImage("platforms/carrot/mid.png")
	Carrot.bot = game:newImage("platforms/carrot/bot.png")
	Carrot.depth = -3
	Carrot.starty = Carrot.rect.y
	Carrot.startw = Carrot.rect.w
	Carrot.returntimer = game:Timer(0.2)

	function Carrot:step(dt)
		local i
		self.collided = false
		local moveforce = 0
		for i,v in ipairs(self.game:findName("GravityAffected")) do
			if v.rect:colliderect(self.rect,0,v.gravityway) then
				moveforce = moveforce + 1
			end
		end

		if moveforce == 0 then
			self.returntimer:tick(dt)
			if self.returntimer.loops>=1 then
				moveforce = 0.5
				if self.rect.y>self.starty then moveforce = moveforce * -1 end
			end
		else
			self.returntimer = game:Timer(0.2)
		end
		self:move(0,moveforce*dt*40)
	end

	function Carrot:draw()
		lg.draw(self.sprout,self.rect.x-self.game.camerax,self.rect.y-self.sprout:getHeight()-self.game.cameray)
		local i
		local sprite
		for i=1,self.rect.h/16 do
			sprite = self.mid
			if i==1 then sprite = self.top end
			if i==math.floor(self.rect.h/16) then sprite = self.bot end
			lg.draw(sprite,self.rect.x-self.game.camerax,self.rect.y+(i-1)*16-self.game.cameray)
		end
	end

end

return gen
