local gen = {}

function gen:new(game,args)

	local Coin = game.objects.movable:new(game,args.x,args.y,args.width,args.height)

	Coin.sprites = game:getSpriteDir("coin/")
	Coin.timer = game:Timer(0.15)
	Coin:register("Coin")
	Coin.timer:tick((Coin.rect.x+Coin.rect.y)/800)
	Coin.taken = false
	Coin.players = {}
	Coin.args = args

	function Coin:step(dt)
		if not self.taken then
			self.timer:tick(dt)
			if #self.players==0 then
				self.players = game:findName("Player")
			end
			local i
			for i=1,#self.players do
				if self.players[i].rect:colliderect(self.rect) then
					self.taken = true
				end
			end
			if self.taken then
				local p = self.game.objects.particle:new(game,self.rect.center.x,self.rect.center.y,"particles/sparkles/",0,0,0,0,10)
				p.depth = 3
			end
		end
	end

	function Coin:draw()
		if not self.taken then
			lg.draw(self.sprites[self.timer.loops%#self.sprites+1],self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
		end
	end

	return Coin

end

return gen
