local gen = {}

function gen:new(game,args)
	local sprite = game:newImage("doors/main.png")
	if args.properties.playerspawnid then sprite = game:newImage("doors/secondary.png") end
	local Door = game.objects.base:new(game,args.x,args.y,sprite:getWidth(),sprite:getHeight())
	Door.sprite = sprite
	Door:register("Door")
	Door.point = game:newImage("point.png")
	Door.sintimer = 0
	Door.depth = -1.5
	Door.nextroom = args.properties.room or "demo"
	Door.playerspawnid = args.properties.playerspawnid
	Door:register("Door")

	function Door:step(dt)
		self.sintimer = self.sintimer + dt*2
		local i
		local v
		for i,v in ipairs(self.game:findName("Player")) do
			if self.rect:collidepoint(v.rect.center.x,v.rect.center.y) and v.onground and math.abs(v.currentspeed)<v.basespeed*0.8 then
				if self.game.inputs.actions.down.timer == 1 or self.game.inputs.actions.up.timer == 1 then
					local args = {}
					args.level = self.nextroom
					args.playerspawnid = self.playerspawnid
					v.state = v.stillstate
					game.objects.transition:new(game,nil,"main",args)
				end
			end
		end
	end

	function Door:draw()
		if not self.playerspawnid then
			local offy = math.sin(self.sintimer)*2
			lg.draw(self.point,self.rect.center.x-self.point:getWidth()/2-self.game.camerax,self.rect.y+offy-5-self.game.cameray)
		end
		lg.draw(self.sprite,self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
	end

	return Door

end

return gen
