local gen = {}

function gen:new(game,args)

	local sprites = game:getSpriteDir("flags/blue/")
	local w = sprites[1]:getWidth()
	local h = sprites[1]:getHeight()
	args.x = args.x+args.width/2-w/2
	args.y = args.y+args.height-h
	local Flag = game.objects.base:new(game,args.x,args.y,w,h)
	Flag:register("Flag")
	Flag.sprites = sprites
	Flag.timer = game:Timer(0.2)
	Flag.victory = false

	function Flag:step(dt)
		self.timer:tick(dt)
		if not self.victory then
			local i
			local v
			for i,v in ipairs(self.game:findName("Player")) do
				if v.rect:colliderect(self.rect) then
					self.victory = true
					self.sprites = game:getSpriteDir("flags/green/")
					self.game.uniquedied = {}
					v.state = v.stillstate
					self.game.objects.transition:new(game,nil,"main",{})
				end
			end
		end
	end

	function Flag:draw()
		local sprite = self.sprites[self.timer.loops%#self.sprites+1]
		lg.draw(sprite,self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
	end

	return Flag
end

return gen
