local gen = {}

function gen:new(game,args)
	local Apple = game.objects.enemy:new(game,args)
	Apple.sprites = game:getSpriteDir("enemies/apple/")
	Apple:register("GravityAffected")
	Apple:register("Apple")
	Apple.gravityway = args.properties.gravityway or 1
	Apple.hurtsprite = game:newImage("enemies/apple/4.png")
	Apple.timer = game:Timer(0.05)
	Apple.direction = args.properties.direction or -1
	Apple.verspeed = 0
	Apple.detected = false --not args.properties.detect
	Apple.detecttimer = game:Timer(0.5)
	Apple.jump = -250
	Apple.speed = 0

	function Apple:step(dt)
		self:basestep(dt)
		if self.onscreen then
			if self:checkcollisions(self.direction,0) then
				self.direction = self.direction*-1
			end
			if self.detected then
				self.detecttimer:tick(dt)
				if self.detecttimer.loops>0 then
					self.timer:tick(dt)
					self.verspd = self.verspd + self.game.gravity*dt*self.gravityway*0.8
				end
			else
				local i
				local v
				for i,v in ipairs(self.game:findName("Player")) do
					if math.abs(self.rect.center.x-v.rect.center.x)<50 then
						self.detected = true
					end
				end
				if self.detected then
					local i
					for i=1,10 do
						local offx = math.random(-8,8)
						local offy = math.random(-8,8)
						local p = self.game.objects.particle:new(game,self.rect.center.x+offx,self.rect.center.y+offy,"particles/leaves/",0,10,0,0,8)
						p.depth = 3
					end
				end
			end
			local speed = self.speed
			if self:checkcollisions(0,1,true) then
				self.verspd = self.jump
				self.jump = self.jump * 0.8
				if math.abs(self.jump) < 100 then self.jump = 0 end
				self.speed = 40
				speed = speed*2
			end
			self:move(self.direction*speed*dt,self.verspd*dt)
		end
	end

	function Apple:respawnhook()
		self.verspd = 0
		self.detected = false --not args.properties.detect
		self.detecttimer = game:Timer(0.5)
		self.jump = -250
		self.timer.loops = 0
		self.speed = 0
	end

	function Apple:draw()
		local index = self.timer.loops%#self.sprites+1
		local sprite = self.sprites[index]
		local scalex = 1
		local scaley = 1
		if self.direction<0 then scalex = -1 end
		if self.gravityway<0 then scaley = -1 end
		if self.hp > 0 then
			lg.draw(sprite,self.rect.x+self.rect.w/2-self.game.camerax,self.rect.y+self.rect.h/2-self.game.cameray,0,scalex,scaley,self.rect.w/2,self.rect.h/2)
		end
	end

	return Apple 

end

return gen
