local gen = {}

function gen:new(game,args)
	local Bird = game.objects.enemy:new(game,args)

	Bird.spritedir = args.properties.spritedir or "bird"
	Bird.sprites = game:getSpriteDir("enemies/"..Bird.spritedir.."/")
	Bird.hurtsprite = game:newImage("enemies/"..Bird.spritedir.."/hurt.png")
	Bird.timer = game:Timer(0.15)
	Bird:register("Bird")

	function Bird:step(dt)
		if self.onscreen and self.hp > 0 then
			self.timer:tick(dt)
			self.rect:move(-30*dt,0)
		end
		self:basestep(dt)
	end

	function Bird:draw()
		if self.hp > 0 then
			local offy = math.sin((self.timer.loops-self.timer:getratio())/2)*2
			lg.draw(self.sprites[self.timer.loops%#self.sprites+1],self.rect.x-self.game.camerax,self.rect.y-self.game.cameray+offy)
		end
	end

	return Bird
end

return gen
