local gen = {}

function gen:new(game,args)
	local sprites = game:getSpriteDir("enemies/bug/")
	local gravityway = args.properties.gravityway or 1
	local scale = args.properties.scale or 1
	args.y = args.y+args.height*gravityway-sprites[1]:getHeight()*gravityway*scale
	args.width = sprites[1]:getWidth()*scale
	args.height = sprites[1]:getHeight()*scale
	local Bug = game.objects.enemy:new(game,args)
	Bug.sprites = sprites
	Bug:register("GravityAffected")
	Bug:register("Bug")
	Bug.gravityway = gravityway
	Bug.hurtsprite = game:newImage("enemies/bug/hurt.png")
	Bug.fallingsprite = game:newImage("enemies/bug/falling.png")
	Bug.timer = game:Timer(0.2)
	Bug.hp = scale
	Bug.maxhp = scale
	Bug.direction = args.properties.direction or -1
	Bug.verspeed = 0

	function Bug:step(dt)
		self:basestep(dt)
		if self.onscreen then
			if self:checkcollisions(self.direction,0) then
				self.direction = self.direction*-1
			end
			self.verspd = self.verspd + self.game.gravity*dt*self.gravityway
			if self:checkcollisions(0,1,true) then self.verspd = 0 end
			self:move(self.direction*20*dt*math.sqrt(self.hp),self.verspd*dt)
			self.timer:tick(dt)
		end
	end

	function Bug:hithook(fastfall)
		if fastfall then
			self.hp = 0
		else
			if self.hp>0 then
				local p = self.game.objects.particle:new(game,self.rect.center.x,self.rect.center.y,"particles/spinningdust/",0,0,0,0,10)
				p.depth = 3
				self.rect:move((self.rect.w-self.rect.w/(self.hp+1)*self.hp)/2,(self.rect.h-self.rect.h/(self.hp+1)*self.hp)/2)
				self.rect:setSize(self.rect.w/(self.hp+1)*self.hp,self.rect.h/(self.hp+1)*self.hp)
				local hit = game.rect:new(self.rect.x,self.rect.y,self.rect.w,self.rect.h)
				self.hitrects = {hit}
				self:rehook()
				self.verspd = self.gravityway*-100
			end
		end
	end

	function Bug:respawnhook()
		self.direction = self.args.properties.direction or -1
		local hit = game.rect:new(self.rect.x,self.rect.y,self.rect.w,self.rect.h)
		self.hitrects = {hit}
		self:rehook()
	end

	function Bug:draw()
		local index = self.timer.loops%#self.sprites+1
		local sprite = self.sprites[index]
		if self.verspd>0 then
			sprite = self.fallingsprite
		end
		local scalex = 1
		local scaley = 1
		if self.direction<0 then scalex = -1 end
		if self.gravityway<0 then scaley = -1 end
		if self.hp>0 then
			lg.draw(sprite,self.rect.x+self.rect.w/2-self.game.camerax,self.rect.y+self.rect.h/2-self.game.cameray,0,scalex*self.hp,scaley*self.hp,self.rect.w/self.hp/2,self.rect.h/self.hp/2)
		end
	end

	return Bug

end

return gen
