local gen = {}

function gen:new(game,args)

	local Enemy = game.objects.movable:new(game,args.x,args.y,args.width,args.height)
	
	Enemy.spawnrect = game.rect:new(Enemy.rect.x,Enemy.rect.y,Enemy.rect.w,Enemy.rect.h)
	local hit = game.rect:new(Enemy.rect.x,Enemy.rect.y,Enemy.rect.w,Enemy.rect.h)
	Enemy.hitrects = {hit}
	Enemy:register("Enemy")
	Enemy.onscreen = false
	Enemy.args = args
	Enemy.permadie = args.properties.permadie
	Enemy.force = 300
	Enemy.respawn = true
	Enemy.maxhp = 1
	Enemy.hp = Enemy.maxhp

	function Enemy:rehook()
		self.rect:clearhook()
		local i
		local v
		for i,v in ipairs(self.hitrects) do
			self.rect:hook(v)
		end
	end
	Enemy:rehook()

	function Enemy:isOnScreen(rect)
		if not rect then rect = self.rect end
		local margin = 5
		return rect:colliderect(game.rect:new(self.game.camerax-margin,self.game.cameray-margin,self.game.WIDTH+margin,self.game.HEIGHT+margin))
	end

	function Enemy:basestep(dt)
		self.onscreen = self:isOnScreen()
		if self.onscreen and self.hp > 0 then
			local i
			local v
			local j
			local r
			local hitted = {}
			for i,v in ipairs(self.game:findName("Player")) do
				for j,r in ipairs(self.hitrects) do
					if r:colliderect(v.rect,0,-v.gravityway*3) and v.verspd*v.gravityway>0.2 then
						table.insert(hitted,v)
					end
				end
			end
			if #hitted==0 then
				for i,v in ipairs(self.game:findName("Player")) do
					local margin = 2
					if self.rect:colliderect(v.rect,margin,0) and self.rect:colliderect(v.rect,-margin,0) then
						local dir = 1
						if self.rect.center.x>v.rect.center.x then dir = -1 end
						v:yeet(dir*self.force,v.gravityway*-1*self.force)
					end
				end
			end
			for i,v in ipairs(hitted) do
				if not v.fastfall then v.verspd = v.jump*v.gravityway end
				self.hp = self.hp - 1
				self:hithook(v.fastfall)
			end
			if self.hp <= 0 then
				self:die()
			end
		elseif not self:isOnScreen(self.spawnrect) and not self.permadie then
			self.rect:move_ip(self.spawnrect.x,self.spawnrect.y)
			self.rect:setSize(self.spawnrect.w,self.spawnrect.h)
			self.hp = self.maxhp
			self:respawnhook()
		end
	end

	function Enemy:die()
		self.game.objects.particle:new(game,self.rect.center.x,self.rect.center.y,{self.hurtsprite},0,-140,0,450,0.5,1)
		local p = self.game.objects.particle:new(game,self.rect.center.x,self.rect.center.y,"particles/spinningdust/",0,0,0,0,10)
		p.depth = 3
		self.rect:setSize(0,0)
		if self.permadie then self.tileset:permadie(self.args) end
	end

	function Enemy:hithook(fastfall) end
	function Enemy:respawnhook() end

	function Enemy:step(dt)
		self:basestep(dt)
	end

	return Enemy
end

return gen
