local gen = {}

function gen:new(game,args)

	local sprites = game:getSpriteDir("enemies/squid/")
	args.width = sprites[1]:getWidth()
	args.height = sprites[1]:getHeight()
	local Squid = game.objects.enemy:new(game,args)
	Squid.hurtsprite = game:newImage("enemies/squid/hurt.png")
	Squid.sprites = sprites
	Squid:register("Squid")
	Squid.timer = game:Timer(0.2)
	Squid.fallingway = -1
	Squid.distance = args.properties.distance or 16*5
	Squid.starty = Squid.rect.center.y
	Squid.verspd = 0

	function Squid:step(dt)
		self:basestep(dt)
		self.timer:tick(dt)
		if self.onscreen and self.hp>0 then
			if self.starty-self.rect.center.y>self.distance and self.timer.loops%#self.sprites==1 then
				self.fallingway = 1
				self.verspd = 0
			elseif self.rect.center.y>=self.starty then
				self.fallingway = -1
			end
			if self.fallingway>0 then
				self.verspd = self.verspd + self.game.gravity*dt/3
				self.rect:move(0,dt*(self.verspd+3))
			else
				local rates = {1,0.5,1.5}
				self.rect:move(0,-dt*rates[self.timer.loops%#self.sprites+1]*20)
			end
		end
	end

	function Squid:draw()
		if self.hp>0 then
			local sprite = self.sprites[self.timer.loops%#self.sprites+1]
			if self.fallingway>0 then sprite = self.sprites[2] end
			lg.draw(sprite,self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
		end
	end

	return Squid

end

return gen
