local gen = {}

function gen:new(game,args)

	args.properties["sprite"] = args.properties["sprite"] or "donut.png"
	args.properties["semi"] = args.properties["semi"] or true
	args.properties["drag"] = args.properties["drag"] or false
	local Falling = game.objects.movingplatform:new(game,args)
	Falling:register("FallingPlatform")
	Falling.maxshaketimer = 0.2
	Falling.depth = 1
	Falling.shaketimer = 0
	Falling.starty = Falling.rect.y
	Falling.startw = Falling.rect.w
	Falling.basespeed = 0
	Falling.speed = Falling.basespeed
	Falling.spawntimer = game:Timer(1)
	Falling.spawnloops = 4
	Falling.spawntimer.loops = Falling.spawnloops
	Falling.acc = 600
	Falling.alpha = 1

	function Falling:step(dt)
		if self.spawntimer.loops<self.spawnloops then
			if self.spawntimer.loops>=self.spawnloops-1 then
				self.alpha = 1-self.spawntimer:getratio()
				self.rect.w = self.startw
				self.rect.disabled = false
				self.rect:move_ip(self.rect.x,self.starty)
				self.speed = self.basespeed
			end
			if self.spawntimer:tick(dt) then
				if self.spawntimer.loops==self.spawnloops then
					self.alpha = 1
				end
			end
		end
		local i
		self.collided = false
		for i,v in ipairs(self.game:findName("Movable")) do
			if v.rect:colliderect(self.rect,0,1) then
				self.collided = true
			end
		end
		if self.collided then self.shaketimer = self.shaketimer + dt,self.maxshaketimer
		else self.shaketimer = math.max(0,self.shaketimer - dt*2) end

		if self.shaketimer>=self.maxshaketimer then
			self.falling = true
		end
		if self.falling then
			self:move(0,dt*self.speed)
			self.speed = self.speed + self.acc*dt
			if self.rect.y-self.game.cameray>self.game.HEIGHT+32 then
				self.falling = false
				self.alpha = 0
				self.rect.disabled = true
				self.spawntimer.loops = 0
				self.rect.w = 0
			end
		end
	end

	function Falling:draw()
		local ratio = self.shaketimer/self.maxshaketimer
		ratio = math.min(1,ratio)
		local offx = math.sin(self.shaketimer*40)*(1+ratio/2)
		if not self.collided or self.falling then offx = 0 end
		lg.setColor(1,1-ratio,1-ratio,self.alpha)
		lg.draw(self.sprite,self.rect.x-self.game.camerax+offx,self.rect.y-self.game.cameray)
		lg.setColor(1,1,1,1)
	end

end

return gen
