local gen = {}

function gen:new(game,args)
	local dirs = {"blue","yellow","white"}
	local spritedir = args.properties["sprite"] or "deco/flowers/"..dirs[math.random(#dirs)].."/"
	local sprites = game:getSpriteDir(spritedir)
	local w = sprites[1]:getWidth()
	local h = sprites[1]:getHeight()
	local x = args.x+math.min(args.width,16)/2-w/2
	local y = args.y+args.height-h
	local Flower = game.objects.base:new(game,x,y,w,h)
	Flower:register("Flowerpot")
	Flower.timer = game:Timer(0.6)
	Flower.sprites = sprites
	Flower.depth = -1
	if args.width>16 then
		args.width = args.width - 16
		args.x = args.x + 16
		gen:new(game,args)
	end
	Flower.pot = game:newImage("deco/pot.png")

	function Flower:step(dt)
		self.timer:tick(dt)
	end

	function Flower:draw()
		local posx = self.rect.x-self.game.camerax
		local posy = self.rect.y-self.game.cameray
		lg.draw(self.sprites[self.timer.loops%#self.sprites+1],posx,posy-self.pot:getHeight()+1)
		lg.draw(self.pot,posx+(self.rect.w-self.pot:getWidth())/2,posy+self.rect.h-self.pot:getHeight())
	end

	return Flower
end

return gen
