movgen = {}

function movgen:new(game,x,y,w,h)

	Movable = game.objects.base:new(game,x,y,w,h)
	Movable:register("Movable")
	Movable.tileset = game:findName("Tileset")[1]
	Movable.water = game:findName("Water")
	Movable.hrest = 0
	Movable.vrest = 0
	Movable.verspd = 0

	function Movable:inWater(offx,offy)
		result = false
		if self.water[1] and not self.water[1].decorative then
			result = offy+self.rect.up>self.water[1].collision.y
		end
		self.water = self.game:findName("Water")
		--for i,rect in ipairs(self.tileset.water) do
			--if rect:collidepoint(self.rect.center.x+offx,self.rect.center.y+offy) then
				--result = true
			--end
		--end
		return result
	end

	function Movable:move(x,y,semisolid)
		local tilew = 15
		local tileh = 15
		local totalx = math.floor(x+self.hrest)
		local origintotalx = totalx
		local totaly = math.floor(y+self.vrest)
		self.hrest = self.hrest+x-totalx
		self.vrest = self.vrest+y-totaly
		local moved = false
		while math.abs(totalx)>0 do
			print("			"..totalx)
			local step = totalx
			if step>tilew then step = tilew end
			if step<-tilew then step = -tilew end
			local rect = self:checkcollisions(step,0)
			if rect then
				if step>0 then
					self.rect:move_ip(rect.left-self.rect.w,self.rect.y)
				else
					self.rect:move_ip(rect.right,self.rect.y)
				end
				totalx = 0
			else
				self.rect:move(step,0)
				moved = true
				totalx = totalx - step
			end
		end
		while math.abs(totaly)>0 do
			print("			"..totaly)
			local step = totaly
			if step>tileh then step = tileh end
			if step<-tileh then step = -tileh end
			local rect = self:checkcollisions(0,step,true)
			if rect then
				if step>0 then
					self.rect:move_ip(self.rect.x,rect.up-self.rect.h)
				else
					self.rect:move_ip(self.rect.x,rect.down)
				end
				totaly = 0
			else
				--moved = true
				self.rect:move(0,step)
				totaly = totaly - step
			end
		end
		return moved or origintotalx==0
	end

	function Movable:checkcollisions(offx,offy,semisolids,nonormal,onlyfalltrough)
		local result = false
		if not nonormal then
			for i,rect in pairs(self.tileset.solids) do
				if rect~=self.rect and self.rect:colliderect(rect,offx,offy) then
					result = rect
					break
				end
			end
		end
		if not result and semisolids then
			for i,rect in pairs(self.tileset.semisolids) do
				if rect~=self.rect and self.rect.down<=rect.up and self.rect:colliderect(rect,offx,offy) and not (onlyfalltrough and rect.nofalltrough)then
					result = rect
					break
				end
			end
		end
		return result
	end
	function Movable:checkspikes(offx,offy)
		local offx = offx or 0
		local offy = offy or 0
		local result = false
		for i,rect in pairs(self.tileset.spikes) do
			if rect~=self.rect and self.rect:colliderect(rect,offx,offy) then
				result = rect
				break
			end
		end
		return result
	end

	return Movable

end

return movgen
