local gen = {}

function gen:new(game,args)
	local x = args.x or 0
	local y = args.y or 0
	local w = args.width or 0
	local h = args.height or 0
	local Moving = game.objects.base:new(game,x,y,w,h)
	Moving.semisolid = args.properties["semi"]
	Moving:register("MovingPlatform")
	Moving.drag = args.properties["drag"]
	if Moving.drag==nil then Moving.drag = true end
	local spritename = args.properties["sprite"] or "semisolid.png"
	Moving.sprite = game:newImage("platforms/"..spritename)
	local tileset = game:findName("Tileset")[1]
	if Moving.semisolid then
		table.insert(tileset.semisolids,Moving.rect)
	else
		table.insert(tileset.solids,Moving.rect)
	end
	function Moving:move(mx,my)
		local movables = self.game:findName("Movable")
		self.rect:move(mx,0)
		if not self.semisolid then
			for i,v in ipairs(movables) do
				if v.rect:colliderect(self.rect) then
					if mx>0 then
						v.rect:move_ip(self.rect.right,v.rect.y)
					elseif mx<0 then
						v.rect:move_ip(self.rect.left-v.rect.w,v.rect.y)
					end
				end
			end
		end
		self.rect:move(0,my)
		print("	MovingPlatform : "..mx..";"..my)
		if self.drag then
			for i,v in ipairs(movables) do
				if (not self.semisolid or v.rect.down<=self.rect.up) and v.rect:colliderect(self.rect,0,2) then
					v:move(mx,my)
				end
			end
		end
		for i,v in ipairs(movables) do
			if (my < 0 and v.rect.down<=self.rect.up-mx+1 or not self.semisolid) and v.rect:colliderect(self.rect) then
				if my>0 then
					v.rect:move_ip(v.rect.x,self.rect.down)
				elseif my<0 then
					v.rect:move_ip(v.rect.x,self.rect.up-v.rect.h)
				end
			end
		end
	end

	function Moving:draw()
		lg.draw(self.sprite,self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
	end

	return Moving
end

return gen
