local gen = {}

function gen:new(game,args)
	local dirs = {"red","brown"}
	local spritedir = args.properties["sprite"] or "deco/mushrooms/"..dirs[math.random(#dirs)].."/"
	local sprites = game:getSpriteDir(spritedir)
	local w = sprites[1]:getWidth()
	local h = sprites[1]:getHeight()
	local x = args.x+math.min(args.width,16)/2-w/2
	local y = args.y+args.height-h
	local Flower = game.objects.base:new(game,x,y,w,h)
	Flower.timer = game:Timer(0.8)
	Flower:register("Mushroom")
	Flower.depth = -1
	Flower.timer:tick(0.8*math.random(1,10)/10)
	Flower.sprites = sprites
	if args.width>16 then
		args.width = args.width - 16
		args.x = args.x + 16
		gen:new(game,args)
	end

	function Flower:step(dt)
		self.timer:tick(dt)
	end

	function Flower:draw()
		lg.draw(self.sprites[self.timer.loops%#self.sprites+1],self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
	end

	return Flower
end

return gen
