local gen = {}

function gen:new(game,x,y,spritedir,speedx,speedy,modx,mody,fps,depth,fade)

	local Particle = game.objects.base:new(game,x,y)

	if type(spritedir)=="string" then Particle.sprites = game:getSpriteDir(spritedir)
	else Particle.sprites = spritedir end
	local fps = fps or 5
	Particle.timer = game:Timer(1/fps)
	Particle.speedx = speedx or 0
	Particle.speedy = speedy or 0
	Particle.modx = modx or 0
	Particle.mody = mody or 0
	Particle.depth = depth or 1
	Particle.fade = fade
	Particle:register("Particle")

	function Particle:step(dt)
		self.rect:move(self.speedx*dt,self.speedy*dt)
		self.speedx = self.speedx+self.modx*dt
		self.speedy = self.speedy+self.mody*dt
		if self.timer:tick(dt) and self.timer.loops>=#self.sprites then
			self.game:delid(self.id)
		end
	end

	function Particle:draw()
		local index = math.min(#self.sprites,1+self.timer.loops)
		local sprite = self.sprites[index]
		if self.fade then
			alpha = 1-(self.timer.loops+1-self.timer:getratio())/#self.sprites
			lg.setColor(1,1,1,alpha)
		end
		lg.draw(sprite,self.rect.x-sprite:getWidth()/2-self.game.camerax,self.rect.y-sprite:getHeight()/2-self.game.cameray)
		lg.setColor(1,1,1,1)
	end

	return Particle
end

return gen
