local gen = {}

function gen:new(game,args)

	local Sign = game.objects.base:new(game,args.x,args.y,args.width,args.height)
	if args.properties.text then
		Sign.text = game.texts[args.properties.text]
	else
		Sign.text = "SPHINX OF BLACK QUARTZ\nJUDGE MY VOW §"
	end
	Sign.image = false
	Sign:register("Sign")
	Sign.sprite = game:newImage("deco/sign.png")
	Sign.textsprites = game:getchars(Sign.text)
	Sign.hitrect = game.rect:new(Sign.rect.x-5,Sign.rect.y,Sign.rect.w+10,Sign.rect.h)
	Sign.rect:hook(Sign.hitrect)
	Sign.attention = game:getchar("!")
	Sign.depth = -1
	Sign.speak = game:newImage("speak.png")
	
	Sign.spacing = 3

	Sign.maxheight = #Sign.textsprites*game.fontheight+(#Sign.textsprites-1)*Sign.spacing
	Sign.maxwidth = 0
	local i
	for i=1,#Sign.textsprites do
		Sign.maxwidth = math.max(Sign.maxwidth,#Sign.textsprites[i]*game.fontwidth)
	end
	Sign.show = false
	Sign.sintimer = 0
	Sign.alpha = 0

	function Sign:step(dt)
		local i
		local v
		self.show = false
		for i,v in ipairs(self.game:findName("Player")) do
			if self.hitrect:colliderect(v.rect,0,0) then
				self.show = true
			end
		end
		self.sintimer = self.sintimer+dt*4
		if self.show then self.alpha = self.alpha + dt*3
		else self.alpha = self.alpha - dt end
		self.alpha = math.min(1,math.max(0,self.alpha))
	end

	function Sign:draw()
		if self.alpha>0 then
			local j
			local i
			local v
			local offy = 10
			local counter = 0
			lg.setColor(0,0,0,self.alpha/2)
			local margin = 3
			lg.rectangle('fill',self.rect.center.x-self.game.camerax-self.maxwidth/2-margin,self.rect.y-offy-margin-self.game.cameray-self.maxheight,self.maxwidth+margin*2,self.maxheight+margin*2)
			lg.draw(self.speak,self.rect.center.x-self.game.camerax-self.speak:getWidth()/2-margin,self.rect.y-offy+margin-self.game.cameray)
			lg.setColor(1,1,1,self.alpha)
			for i=1,#self.textsprites do
				for j=1,#self.textsprites[i] do
					local offx = #self.textsprites[i]/2*game.fontwidth
					local dx = self.rect.center.x-self.game.camerax-offx+(j-1)*game.fontwidth
					local dy = self.rect.y-self.game.cameray-offy+(i-1)*(game.fontheight+self.spacing)-self.maxheight + math.sin(counter+self.sintimer)
					lg.draw(self.textsprites[i][j],math.floor(dx),math.floor(dy))
					counter = counter + 1
				end
			end
		end
		if self.attention then
			lg.setColor(1,1,1,1-self.alpha)
			lg.draw(self.attention,math.floor(self.rect.center.x-self.attention:getWidth()/2-self.game.camerax),self.rect.y-10+math.sin(self.sintimer)*2-self.game.cameray)
			if self.alpha==1 then self.attention = false end
		end
		lg.setColor(1,1,1,1)
		lg.draw(self.sprite,self.rect.x-self.game.camerax-2,self.rect.y-self.game.cameray)
	end

	return Sign
end

return gen
