local gen = {}

function gen:new(game,args)

	local Spring = game.objects.base:new(game,args.x,args.y,args.width,args.height)
	local spritesnormal = game:getSpriteDir("spring/normal/")
    local spritesside = game:getSpriteDir("spring/side/")
    local spritesdiagonal = game:getSpriteDir("spring/diagonal/")
	local angle = args.properties["angle"] or 0
	-- Sprites,flipx,flipy
    local orientations = {{spritesnormal,false,false},{spritesdiagonal,false,false},{spritesside,false,false},{spritesdiagonal,false,true},{spritesnormal,false,true},{spritesdiagonal,true,true},{spritesside,true,false},{spritesdiagonal,true,false}}
    local orientation = orientations[math.ceil((angle/360*#orientations))%#orientations+1]
    Spring.sprites = {}
	local i
	local v
    for i,v in ipairs(orientation[1]) do
        table.insert(Spring.sprites,game:flip(v,orientation[2],orientation[3]))
	end
	local dist = 10
	Spring:register("Spring")
	Spring.angle = math.rad(angle)-math.pi/2
	Spring.distx = math.cos(Spring.angle)
	Spring.disty = math.sin(Spring.angle)
	Spring.force = args.properties["force"] or 7
	Spring.hitsize = 10
	Spring.timer = game:Timer(0.05)
	Spring.timer.loops = #Spring.sprites

	function Spring:step(dt)
		if self.timer.loops<#self.sprites then self.timer:tick(dt) end
		local i
		local v
		local force
		for i,v in ipairs(self.game:findName("Player")) do
			force = 50
			local distx = self.rect.center.x+self.distx-v.rect.center.x
			local disty = self.rect.center.y+self.disty-v.rect.center.y
			if math.sqrt(distx*distx+disty*disty)<=self.hitsize and (self.disty*v.verspd<0) then
				if v.fastfall then
					force=force*1.25
				end
				v:yeet(self.force*self.distx*force,self.force*self.disty*force,true)
				self.timer.loops = 0
			end
		end
	end

	function Spring:draw()
		local index = self.timer.loops
		lg.draw(self.sprites[index%#self.sprites+1],self.rect.x-self.game.camerax,self.rect.y-self.game.cameray)
	end


	return Spring

end

return gen
