local gen = {}

local sti = require "lib/sti"

function gen:new(game,x,y,mapname,playerspawnid)

	local Tileset = game.objects.base:new(game,x,y)
	Tileset.depth = -2
	Tileset.mapname = mapname
	Tileset.solids = {}
	Tileset.semisolids = {}
	Tileset.spikes = {}
	Tileset:register("Tileset")
	local mapname = mapname or "main"
	Tileset.map = sti("maps/"..mapname..".lua")
	Tileset.mapname = mapname
	local bg = Tileset.map.properties.bg
	if bg then
		game.scenes[bg](game)
	end
	local bgm = Tileset.map.properties.bgm
	if bgm then game:playbgm(bgm) end
	Tileset.playerspawnid = playerspawnid
	local playerargs = nil
	for _,v in ipairs(Tileset.map.layers) do
		if v.type=="objectgroup" then
			for __,obj in ipairs(v.objects) do
				if v.name=="solids" or v.name=="semisolids" or v.name=="spikes" then
					local rect = game.rect:new(obj.x,obj.y,obj.width,obj.height)
					table.insert(Tileset[v.name],rect)
				elseif v.name=="player" then
					if not playerargs then playerargs = obj end
				else
					game.objects[v.name]:new(game,obj)
					if obj.id==playerspawnid then playerargs = obj end
				end
			end
		end
	end
	if playerargs then game.objects.player:new(game,playerargs) end

	function Tileset:step(dt)
		--self.map:update(dt)
	end

	function Tileset:draw()
		lg.setColor(0,0,0)
		self.map:draw(-self.game.camerax+3,-self.game.cameray+3)
		lg.setColor(1,1,1)
		self.map:draw(-self.game.camerax,-self.game.cameray)
	end

	return Tileset

end

return gen
