local gen = {}

function gen:new(game,time,func,args)

	local Transition = game.objects.base:new(game,0,0)

	Transition.func = func
	Transition.args = args
	Transition:register("Transition")

	Transition.timer = game:Timer(time or 0.7)

	Transition.depth = 99

	function Transition:step(dt)
		if self.func then
			print("	Transition : "..self.func)
		else
			print("	Transition : none")
		end
		print("Change volume")
		if self.timer.loops== 0 then
			local vol = 1-self.timer:getratio()
			if self.func then
				vol = self.timer:getratio()
			end
			self.game:setVolume(vol)
		end
		print("Scene checker")
		if self.timer:tick(dt) then
			if self.timer.loops == 1 then
            	if self.func then
					self.game.scenes[self.func](self.game,self.args)
                	local t = self.game.objects.transition:new(self.game,self.timer.maxcount)
					self.game:summon(t)
				end
			end
		end
		print("	END Transition")
	end

	function Transition:draw()
		if self.timer.loops<1 then
			local alpha = 1-self.timer:getratio()
        	if not self.func then alpha = self.timer:getratio() end
			lg.setColor(31/255,14/255,28/255,alpha)
        	lg.rectangle("fill",0,0, self.game.WIDTH,self.game.HEIGHT)
			lg.setColor(1,1,1,1)
		end
	end

	return Transition

end

return gen
