local gen = {}

function gen:new(game,args)

	local y = args.y or 50
	local Water = game.objects.base:new(game,0,y)
	Water.decorative = args.properties.decorative
	Water.collision = game.rect:new(0,y,0,0)
	Water:register("Water")
	Water.depth = -2
	Water.sprites = game:getSpriteDir("water/")
	Water.timer = game:Timer(0.4)
	Water.nbtodraw = math.ceil(game.WIDTH/Water.sprites[1]:getWidth())+2
	Water.speed = 0
	Water.moved = 0
	Water.sine = 0
	Water.alpha = args.alpha or 0.2
	if args.alpha then
		Water.depth = 11
	else
		args.alpha = 0.4
		Water.depth = -2.5
		gen:new(game,args)
	end

	function Water:step(dt)
		self.timer:tick(dt)
		self.moved = self.moved + dt * self.speed
		self.sine = self.sine + dt
	end

	function Water:draw()
		local offsety = math.sin(self.sine)*4
		lg.setColor(52/255,133/255,157/255,self.alpha)
		lg.rectangle("fill",0,math.max(0,offsety+self.rect.y-self.game.cameray),self.game.WIDTH,self.game.HEIGHT)
		lg.setColor(1,1,1,1)
		local i
		local sprite = self.sprites[self.timer.loops%#self.sprites+1]
		local offset = (-self.game.camerax*1.25+self.moved)%sprite:getWidth()
		for i=1,self.nbtodraw do
			lg.draw(sprite,(i-2)*sprite:getWidth()+offset,self.rect.y-self.game.cameray+offsety)
		end
	end

	return Water

end

return gen
